﻿ABPURL=http://adblockplus.org/en/subscriptions

/*
Windows Registry Editor Version 5.00

[HKEY_CURRENT_USER\Software\Classes\ABP]
@="URL:AdBlock Plus Protocol"
"URL Protocol"=""

[HKEY_CURRENT_USER\Software\Classes\ABP\DefaultIcon]
@="\"PATH_TO_PLUGIN\\SiteListUpdater.exe\""

[HKEY_CURRENT_USER\Software\Classes\ABP\shell]

[HKEY_CURRENT_USER\Software\Classes\ABP\shell\open]

[HKEY_CURRENT_USER\Software\Classes\ABP\shell\open\command]
@="\"PATH_TO_PLUGIN\\SiteListUpdater.exe\" \"-u=%1\""
*/

;;; Remove abp:// handler
RemoveABP()
{
   GUIMsgBox(GetMsg("UnregABP"))
;   RegDelete, HKEY_CLASSES_ROOT, ABP
   RegDelete, HKEY_CURRENT_USER, Software\Classes\ABP
   GUIExit()
}

SetUpABP()
{
  ;;; Check and setup abp:// handler
;  RegRead, ABPHandler, HKEY_CLASSES_ROOT, ABP\shell\open\command
  RegRead, ABPHandler, HKEY_CURRENT_USER, Software\Classes\ABP\shell\open\command
  If ABPHandler <> "%A_ScriptFullPath%" "-u=`%1"
  {
     GUIMsgBox(GetMsg("RegABP"))
;     RegWrite, REG_SZ, HKEY_CLASSES_ROOT, ABP, , URL:AdBlock Plus Protocol
;     RegWrite, REG_SZ, HKEY_CLASSES_ROOT, ABP, URL Protocol
;     RegWrite, REG_SZ, HKEY_CLASSES_ROOT, ABP\DefaultIcon, , "%A_ScriptFullPath%"
;     RegWrite, REG_SZ, HKEY_CLASSES_ROOT, ABP\shell\open\command, , "%A_ScriptFullPath%" "-u=`%1"
     RegWrite, REG_SZ, HKEY_CURRENT_USER, Software\Classes\ABP, , URL:AdBlock Plus Protocol
     RegWrite, REG_SZ, HKEY_CURRENT_USER, Software\Classes\ABP, URL Protocol
     RegWrite, REG_SZ, HKEY_CURRENT_USER, Software\Classes\ABP\DefaultIcon, , "%A_ScriptFullPath%"
     RegWrite, REG_SZ, HKEY_CURRENT_USER, Software\Classes\ABP\shell\open\command, , "%A_ScriptFullPath%" "-u=`%1"
  }
}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Handle ABP protocol
;;;

ABPSubscribe(abpset)
{   
   StringMid, abpset, abpset, 8
   If SubStr(abpset, 1, 2) = "//"
      StringMid, abpset, abpset, 3

   If ( RegExMatch(abpset, "is)^subscribe") <> 1 )
   {
      GUIMsgBox(GetMsg("ABP_URLerr"))
      GUIExit()
   }

   RegExMatch(abpset, "is)location\=([^\&]*)", location)
   location=%location1%
   location1=

   RegExMatch(abpset, "is)title\=([^\&]*)", title)
   title=%title1%
   title1=

  Loop
  {
     StringGetPos, percentPos, location, `%
     If ((Not location) or (percentPos < 0))
        Break
     location := SubStr(location, 1, percentPos) chr("0x"SubStr(location, percentPos + 2, 2)) SubStr(location, percentPos + 4)
  }
   
   Loop
   {
      StringGetPos, percentPos, title, `%
      If ((Not title) or (percentPos < 0))
         Break
      title := SubStr(title, 1, percentPos) chr("0x" SubStr(title, percentPos + 2, 2)) SubStr(title, percentPos + 4)
   }

   ;UTF8 -> ASCII
   UTF8toASCII(title)
   UTF8toASCII(location)
   
   Filter := "`n" title "=" location

   FileRead Contents, SiteListUpdater.ini

   location:=ToRegEx(location)
   If RegExMatch(Contents, "is)" . location . "$") > 0
   {
      GUIMsgBox(GetMsg("ABP_Exist"))
      GUIExit()
   }
   else
   {
      FileAppend %Filter%, SiteListUpdater.ini
      GUIMsgBox(GetMsg("ABP_Done") ":- " Filter)
   }
}
