﻿#Include ToRegEx.ahk

Setup:
;Read INI
ProcessINI(MxPath)
;Close Tooltip 
GoSub GUIEnd

;;;
;;;Create LV for Filter List
;;;
GUI, 2:Default

GUI, 2:Font, bold
SetupTxt:=GetMsg("FilterTxt")
;GUI, 2:Add, Text, y+15, %SetupTxt%:-
GUI, 2:Add, Text,, %SetupTxt%:-
GUI, 2:Font
SetupTxt:=GetMsg("FilterLV")
GUI, 2:Add, ListView, Checked NoSort NoSortHdr -LV0x10 ReadOnly r7 w500 vFilterList gFilterList, %SetupTxt%
Loop %m2fidx%
{
   iniLine:=M2profile_%A_Index%

   RegExMatch(iniLine, "is)([^\=]*?)\s*?\=\s*?(.*)", iniLinex)
   LV_Add("check", iniLinex1, iniLinex2)

;   StringGetPos, delimPos, iniLine, =
;   StringLeft, FilterName, iniLine, delimPos
;   StringMid, FilterURL, iniLine, delimPos + 2
;   LV_Add("check", FilterName, FilterURL)
}
LV_ModifyCol()  ; Auto-size each column to fit its contents.

;;;
;;;Create other button and object
;;;
SetupTxt:=GetMsg("LocalFile")
GUI, 2:Add, Button, w100 gLocalFile, %SetupTxt%

GUI, 2:Font, bold underline cblue
SetupTxt:=GetMsg("ABPTxt")
;GUI, 2:Add, Text, w380 y+15 gURL, %SetupTxt%
GUI, 2:Add, Text, w380 x+30 yp+5 gURL, %SetupTxt%
GUI, 2:Font
SetupTxt:=GetMsg("BtnOK")
GUI, 2:Add, Button, x+10 yp-5 w50 Default gButtonOK, %SetupTxt%
SetupTxt:=GetMsg("BtnCancel")
GUI, 2:Add, Button, x+10 w50 gButtonCancel, %SetupTxt%



;;;; Proxy
GUI, 2:Font, bold
SetupTxt:=GetMsg("ProxyStr")
Gui, Add, GroupBox, w160 h110 xp-70 y20, %SetupTxt%

iechecked=
nochecked=
mpchecked=
editdisabled=

If Proxy=
{
  iechecked=checked
  Proxy=
  editdisabled=disabled
}
Else If Proxy=-x ""
{
  nochecked=checked
  Proxy=
  editdisabled=disabled
}
Else
{
  RegExMatch(Proxy, "(?<=\"")[^\""]*", Proxy)
  mpchecked=checked
}
  
GUI, 2:Font
SetupTxt:=GetMsg("IEProxyStr")
Gui, Add, Radio, xp+10 yp+20 vProxySetting gieproxy %iechecked%, %SetupTxt% 
SetupTxt:=GetMsg("NoProxyStr")
Gui, Add, Radio, gnoproxy %nochecked%, %SetupTxt%
SetupTxt:=GetMsg("MProxyStr")
Gui, Add, Radio, gproxy %mpchecked%, %SetupTxt%
Gui, Add, Edit, w140 vProxyString %editdisabled%,%proxy%



;;;
;;; Start Setup GUI
;;;
SetupStatus=0
SetupTxt:=GetMsg("SetupTitle")
GUI, 2:Show, , %SetupTxt%

;Loop
;{
;   IfWinNotExist Setup
;      Break
;   Sleep 100
;}
WinWaitClose %SetupTxt%

;;;
;;; Close Setup
;;;
GUI, 1:Default
GUI, 2:Destroy
return

FilterList:
Gui, 2:ListView, FilterList
/*
if A_GuiEvent = DoubleClick
{
    LV_GetText(RowText, A_EventInfo)  ; Get the text from the row's first field.
    ToolTip Filter -- You double-clicked row number %A_EventInfo%. Text: "%RowText%"
}
*/
return

LocalFile:
SetupTxt:=GetMsg("LocalFile")
FileSelectFile, SelectedFile, 3, , %SetupTxt%, Text Documents (*.txt)
if SelectedFile =
{
;    MsgBox, The user didn't select anything.
    return
}

SetupTxt2:=GetMsg("LocalFileName")
InputBox, UserInput, %SetupTxt%, %SetupTxt2%, , 300, 120
if ErrorLevel
{
;    MsgBox, CANCEL was pressed.
    return
}

;MsgBox, % SelectedFile "`n" UserInput "`n..."
LV_Add("check", UserInput, SelectedFile)
LV_ModifyCol()  ; Auto-size each column to fit its contents.


return

URL:
if not wHnd
{
   WinGet, whnd, ID, ahk_class Maxthon2_Frame
}

if wHnd
{
;   Clipboard=%ABPURL%
;   PostMessage, 0x111, 33119, , , ahk_id %wHnd%  ;Address on Clipboard

   Run "%MxPath%\Maxthon.exe" "%ABPURL%"

   SetupStatus=0
   GoSub ButtonCancel
}
return

noproxy:
ieproxy:
  GuiControl,Disabled, ProxyString
  return
proxy:
  GuiControl,Enabled, ProxyString
  return

ButtonCancel:
GUI, 2:Cancel
return

ButtonOK:
GUI, 2:Submit  ; Save the input from the user to each control's associated variable.

; Proxy
If ProxySetting=1
  sProxy=
Else If ProxySetting=2
  sProxy=Proxy=NONE`n`n
Else
  sProxy=Proxy=%ProxyString%`n`n

FilterTxt=
Gui, 2:ListView, FilterList
RowNumber = 0
Loop
{
    RowNumber := LV_GetNext(RowNumber, "Checked")
    if not RowNumber
        break
    LV_GetText(Text1, RowNumber, 1)
    LV_GetText(Text2, RowNumber, 2)
    
    FilterTxt=%FilterTxt%%Text1%=%Text2%`n
}

INITxt:=sProxy . FilterTxt

FileCopy SiteListUpdater.ini, SiteListUpdater.ini.bak, True
FileDelete SiteListUpdater.ini
FileAppend %INITxt%, SiteListUpdater.ini

SetupStatus=1
return
