﻿;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UpdateSiteList:
/*
  FileAppend %A_Tab%---- ProcessINI -----`n, SLU.log ;;;- Debug -;;;
*/
ProcessINI(MxPath)
;;; Process info in ini

/*
  FileAppend %A_Tab%---- LoadLibrary advapi32.dll -----`n, SLU.log ;;;- Debug -;;;
*/
_MD5_Startup()

Loop, %m2fidx%
{
    if M2profile_%A_Index% =
       continue
    
    RegExMatch(M2profile_%A_Index%, "is)([^\=]*?)\s*?\=\s*?(.*)", iniLinex)
    urlexist = 0
    FilterName=
    FilterURL=
    FilterName=%iniLinex1%
    FilterURL=%iniLinex2%
    iniLinex1=
    iniLinex2=
    
/*
  FileAppend %A_Tab%%A_Tab%>>>>>>`n, SLU.log ;;;- Debug -;;;
  FileAppend %A_Tab%%A_Tab%%A_Tab%< %FilterName% >=< %FilterURL% >`n, SLU.log ;;;- Debug -;;;
*/  
    GUIMsgBox(GetMsg("StartUpd") " " FilterName)

    FileCreateDir, %FilterName%
    FileCopy %FilterName%\abp.txt, %FilterName%\abp_old.txt, True
    IniRead LastUpdate, %FilterName%\version.ini, Version, LastUpdate, 19000101000000
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%> LastUpdate = %LastUpdate%`n, SLU.log ;;;- Debug -;;;
*/
    
    ;download list
    If RegExMatch(FilterURL, "is)http[s]*?\:\/\/") = 1
    {
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%> HTTP`n, SLU.log ;;;- Debug -;;;
*/
       If ((forceupdate = 1) or (SubStr(LastUpdate, 1, 8) + 1 <= SubStr(Today, 1, 8)))
       {
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%> cURL download`n, SLU.log ;;;- Debug -;;;
*/
           RunWait curl.exe %Proxy% --insecure --dump-header "%FilterName%\header" --output "%FilterName%\abp.txt" --time-cond "%FilterName%\abp.txt" "%FilterURL%",, Hide UseErrorLevel
           If ErrorLevel <> 0
           {
             GUIMsgBox(GetMsg("Fail") . " (" . FilterName . " )")
             Sleep 1000
           }
           Else
             IniWrite %Today%, %FilterName%\version.ini, Version, LastUpdate
       }
      
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%%A_Tab%> Read abp.txt`n, SLU.log ;;;- Debug -;;;
*/
       ; Read Filter for checking
       FileRead nContents, %FilterName%\abp.txt
       
       
       ; Check if Valid ABP format           
       ;Header [Adblock..]
       ;;; (Adblock Plus 0.6.1.2 or higher required) [Adblock]
       ;;; [Adblock Plus 0.7.1]
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%%A_Tab%> Check [adblock...] header`n, SLU.log ;;;- Debug -;;;
*/
       if ( RegExMatch(nContents, "is)^(?:" UTF8BOM ")?(?:\([^\)]*\)\s*?)?\[adblock") <> 1 )
       {
           nContents=
           FileCopy %FilterName%\abp.txt, %FilterName%\abp_error.txt, True
           FileCopy %FilterName%\abp_old.txt, %FilterName%\abp.txt, True
           Continue
       }
      
       ;Comment !
       ;;;;;;;;;;
       ;;; http://adblockplus.org/en/faq_internal
       ;;;
       ;;; ! This list expires after 5 days
       ;;; "expires after" or "expires:"
       ;;;
       ;;;;; ----- expire is ignored and check for update every times SiteListupdater start
              
       ;;;;;;;;;;
       ;;; http://adblockplus.org/development-builds/checksum-validation-for-subscription-downloads-added
       ;;;
       ;;; ! Checksum: abcd
       ;;; http://adblockplus.org/forum/viewtopic.php?t=2623
       ;;;
       ;;;;; ----- Validate Checksum
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%%A_Tab%> Check MD5`n, SLU.log ;;;- Debug -;;;
*/
       if ( ABPCheckSumValidate(nContents) = false )
       {
           MsgBox % "Checksum Error: " FilterName "!!!"
           Sleep 1000
           nContents=
           FileCopy %FilterName%\abp.txt, %FilterName%\abp_error.txt, True
           FileCopy %FilterName%\abp_old.txt, %FilterName%\abp.txt, True
           Continue
       }
       
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%%A_Tab%> Check ! redirect`n, SLU.log ;;;- Debug -;;;
*/
       ;;;;;;;;;;
       ;;; ! Redirect: http://example.com/new_list.txt
       ;;; “redirect:” and “redirect to”
       ;;;
       ;;;;; ----- update redirect address of subscription
       RegExMatch(nContents, "is)(?:[\n]!\s*?redirect\s*?(?:\:|to)\s*)([^\s]*)", sRedirectURL)
       sRedirectURL:=sRedirectURL1
       sRedirectURL1=
       if sRedirectURL=
       {
          FileRead header, %FilterName%\header
          
          moved := RegExMatch(header, "i)HTTP\/1\..*?301 Moved Permanently", dummy)
          If moved
          {
            dummy := RegExMatch(header, "i)(?<=Location\:).*", sRedirectURL, moved)
            sRedirectURL=%sRedirectURL%
          }
       }
       if sRedirectURL<>
       {
          UTF8toASCII(sRedirectURL)
          
          FileRead sRedirectINI, SiteListUpdater.ini
          sRedirectINI2:=RegExReplace(sRedirectINI, "im)^(?:[\s]*)?" . ToRegEx(FilterName) . "(?:[\s]*)?\=.*$", "") 
          sRedirectINI2:=RegExReplace(sRedirectINI2, "is)\r", "")
          sRedirectINI2:=RegExReplace(sRedirectINI2, "is)\n+", "`n")

          urlexist:= RegExMatch(sRedirectINI, "i)" . sRedirectURL)
          if urlexist = 0
          {
            sRedirectINI2 := sRedirectINI2 . "`n" . FilterName . "=" . sRedirectURL
            sRedirectINI2:=RegExReplace(sRedirectINI2, "is)\r", "")
            sRedirectINI2:=RegExReplace(sRedirectINI2, "is)\n+", "`n")
          }

          FileCopy SiteListUpdater.ini, SiteListUpdater.ini.bak, True
          FileDelete SiteListUpdater.ini
          FileAppend %sRedirectINI2%, SiteListUpdater.ini

          sRedirectINI=
          sRedirectINI2=
       }

       ;;; Reset nContents for next subscription
       nContents=
    }
    else
    {
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%> LocalFile`n, SLU.log ;;;- Debug -;;;
*/
       FileCopy %FilterURL%, %FilterName%\abp.txt, True
       IniWrite %Today%, %FilterName%\version.ini, Version, LastUpdate
    }
    
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%> SQL OLD`n, SLU.log ;;;- Debug -;;;
*/
    InsertSQL(FilterName, "abp_old.txt", "ositelist")
/*
  FileAppend %A_Tab%%A_Tab%%A_Tab%> SQL NEW`n, SLU.log ;;;- Debug -;;;
*/
  if urlexist
    FileRemoveDir, %FilterName%, 1
  else
    InsertSQL(FilterName, "abp.txt", "nsitelist")
/*
  FileAppend %A_Tab%%A_Tab%<<<<<<`n, SLU.log ;;;- Debug -;;;
*/
sRedirectURL=
}
/*
  FileAppend %A_Tab%---- FreeLibrary advapi32.dll -----`n, SLU.log ;;;- Debug -;;;
*/
_MD5_Shutdown()

/*
  FileAppend %A_Tab%> Process SiteList.xml for user rules`n, SLU.log ;;;- Debug -;;;
*/
;;; UserList
Process_SiteList(MxPath . "\" . LastAccount . "\Config\SiteList.xml", "usitelist")

;;; Merge into tmp
;;$iRC := _SQLite_Exec($SQLITE_h_DB, "insert into tmp select '', 0, '', domain,  type, regex, item from usitelist where type in ('B', 'W') except select '', 0, '', domain, type, regex, item from ositelist where type in ('B', 'W') union select '', 0, '', domain, type, regex, item from nsitelist where type in ('B', 'W');")
;;$iRC := _SQLite_Exec($SQLITE_h_DB, "insert into tmp select * from usitelist where type = 'E' except select * from ositelist where type ='E' union select * from nsitelist where type = 'E';")

/*
  FileAppend %A_Tab%> Merge SQL`n, SLU.log ;;;- Debug -;;;
*/
$iRC := _SQLite_Exec($SQLITE_h_DB, "insert into tmp select * from ( select '', 0, '', domain,  type, regex, item from usitelist where type in ('B', 'W') except select '', 0, '', domain, type, regex, item from ositelist where type in ('B', 'W') union select '', 0, '', domain, type, regex, item from nsitelist where type in ('B', 'W') ) union select * from ( select * from usitelist where type = 'E' except select * from ositelist where type = 'E' union select * from nsitelist where type = 'E' );")
If ($iRC <> $SQLITE_OK)
{
   MsgBox SQLite Exec ERROR: %$iRC% - %$SQLITE_s_ERROR%
   $iRC := _SQLite_CloseDB(-1)
   $iRC := _SQLite_ShutDown()
   GUIExit()
}


Return

;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;
InsertSQL(FilterName, FileName, TableName)
{
    Global UTF8BOM, $SQLITE_OK, $SQLITE_ERROR, $SQLITE_INTERNAL, $SQLITE_PERM, $SQLITE_ABORT, $SQLITE_BUSY, $SQLITE_LOCKED, $SQLITE_NOMEM, $SQLITE_READONLY, $SQLITE_INTERRUPT, $SQLITE_IOERR, $SQLITE_CORRUPT, $SQLITE_NOTFOUND, $SQLITE_FULL, $SQLITE_CANTOPEN, $SQLITE_PROTOCOL, $SQLITE_EMPTY, $SQLITE_SCHEMA, $SQLITE_TOOBIG, $SQLITE_CONSTRAINT, $SQLITE_MISMATCH, $SQLITE_MISUSE, $SQLITE_NOLFS, $SQLITE_AUTH, $SQLITE_ROW, $SQLITE_DONE, $SQLITE_s_VERSION, $SQLITE_s_DLL, $SQLITE_s_EXE, $SQLITE_s_DB, $SQLITE_h_DLL, $SQLITE_h_DB, $SQLITE_h_QUERY, $SQLITE_s_ERROR
    ;;; Insert into SQLite Table
    Loop, read, %FilterName%\%FileName%
    {
/*
OOO_Count := A_Index ;;;- Debug -;;;  
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
  {
    FileAppend %A_Tab%%A_Tab%%A_Tab%%A_Tab%>> %OOO_Count%, SLU.log ;;;- Debug -;;;
    FileAppend `n%A_Tab%%A_Tab%%A_Tab%%A_Tab%%A_Tab%>> FilterTxt = %A_LoopReadLine%, SLU.log ;;;- Debug -;;;
  }
*/
      FilterTxt=%A_LoopReadLine%
      FilterTxt:= RegExReplace(FilterTxt, "is)^\s*" UTF8BOM, "")
      StringReplace FilterTxt, FilterTxt, ', '', ALL
      
      TxtDomain =
      TxtType =
      TxtRegEx =
      TxtItem =

      SQL_str =
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;Empty Line
      If FilterTxt =
      {
        ;;; Nothing to Do, to be ignored
        TxtType = X
      }    
      ;Header [Adblock..]
      ;;; (Adblock Plus 0.6.1.2 or higher required) [Adblock]
      ;;; [Adblock Plus 0.7.1]
      Else If ( RegExMatch(FilterTxt, "is)^(?:" UTF8BOM ")?(?:\([^\)]*\)\s*?)?\[adblock") = 1 )
      {
        ;;; Nothing to Do, to be ignored
        TxtType = H
      }
      ;Comment !
      ;;;;;;;;;;
      ;;; http://adblockplus.org/en/faq_internal
      ;;;
      ;;; ! This list expires after 5 days
      ;;; “expires after” or “expires:”
      ;;; ... Could be ignore and check for update every times SiteListupdater start
      ;;;
      ;;;;;;;;;;
      ;;; ! Redirect: http://example.com/new_list.txt
      ;;; “redirect:” and “redirect to”
      ;;;
      ;;;;;;;;;;
      ;;; http://adblockplus.org/development-builds/checksum-validation-for-subscription-downloads-added
      ;;;
      ;;; ! Checksum: abcd
      ;;; http://adblockplus.org/forum/viewtopic.php?t=2623
      Else If ( RegExMatch(FilterTxt, "is)^!") = 1 )
      {
        ;;; Nothing to Do, to be ignored
        TxtType = !
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;WhiteList @@
      Else If ( RegExMatch(FilterTxt, "is)^@@") = 1 )
      {
        TxtDomain = *
        TxtType = W
        TxtRegEx := RegExMatch(FilterTxt, "is)^@@\/.*\/$") > 0 ? 1 : 0
        If TxtRegEx = 1
        {
          ;;; @@
          TxtItem := RegExReplace(FilterTxt, "is)^@@", "")
          ;;; /.../
          TxtItem := RegExReplace(TxtItem, "is)^\/", "")
          TxtItem := RegExReplace(TxtItem, "is)\/$", "")
        }
        Else
        {
          ;;; @@
          TxtItem := RegExReplace(FilterTxt, "is)^@@", "")
          ;;; Remove filter options $, ********* Not support in Maxthon2 *********
          ;;; 
          ;;; http://adblockplus.org/en/filters
          ;;; $ / $~
          ;;; script — external scripts loaded via HTML script tag
          ;;; image — regular images, typically loaded via HTML img tag
          ;;; background — background images, often specified via CSS
          ;;; stylesheet — external CSS stylesheet files
          ;;; object — content handled by browser plugins, e.g. Flash or Java
          ;;; xbl — XBL bindings (typically loaded by -moz-binding CSS property) Firefox 3 or higher required
          ;;; ping — link pings Firefox 3 or higher required
          ;;; xmlhttprequest — requests started by the XMLHttpRequest object Firefox 3 or higher required
          ;;; object-subrequest — requests started plugins like Flash Firefox 3 or higher required
          ;;; dtd — DTD files loaded by XML documents Firefox 3 or higher required
          ;;; subdocument — embedded pages, usually included via HTML frames
          ;;; document — the page itself (only exception rules can be applied to the page)
          ;;; other — types of requests not covered in the list above (in Firefox 2 this includes XBL bindings and XMLHttpRequests as well)
          ;;;
          ;;; third-party — Restriction to third-party/first-party requests
          ;;; domain — Domain restrictions
          ;;;
          ;;; match-case — makes the filter only apply to addresses with matching letter case
          ;;; collapse — this option will override the global “Collapse blocked elements” and make sure the filter always collapses the element
          
          TxtItem := RegExMatch(TxtItem, "is)\$") > 0 ? "" : TxtItem
          If RegExMatch(TxtItem, "is)^\|") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\|$") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\?") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\^") > 0
            TxtRegEx = 1

          If TxtRegEx = 1
            TxtItem := ToRegEx(TxtItem)
            
          ;;; ||
          If RegExMatch(TxtItem, "is)^\\\|") > 0          
            TxtItem := RegExReplace(TxtItem, "is)^\\\|", "[\/|\.]")
          ;;; ^
          If RegExMatch(TxtItem, "is)\\\^") > 0          
            TxtItem := RegExReplace(TxtItem, "is)\\\^", "[^\w\-\.\%]")          

          TxtItem := RegExReplace(TxtItem, "is)^\.\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\.\*$", "")
          TxtItem := RegExReplace(TxtItem, "is)^\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\*$", "")
        }
        TxtItem := XMLent(TxtItem)
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;CSS ##
      Else If ( RegExMatch(FilterTxt, "is)##") > 0 )
      {
        ;;; Nothing to Do, to be ignored
        TxtType = C
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;Element Hiding #
      Else If ( RegExMatch(FilterTxt, "is)#") > 0 )
      {
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> XMLent(FilterTxt) = " . XMLent(FilterTxt) , SLU.log ;;;- Debug -;;;
*/

        TxtType = E
        
        ;MatchURL
        RegExMatch(FilterTxt, "is)[^#]*", TxtDomain)
        TxtDomain := ToRegEx(TxtDomain)
        
        if instr(TxtDomain, "\,") > 0
        {
           StringReplace TxtDomain, TxtDomain, \`,, |, ALL
           TxtDomain := "(?:" TxtDomain ")"
        }
        TxtDomain:=XMLent(TxtDomain)
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
  {
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtDomain = " . TxtDomain , SLU.log ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtType = " . TxtType , SLU.log ;;;- Debug -;;;
  }
*/

        ;bound
        RegExMatch(FilterTxt, "is)(?<=#)[^\(]*", TxtRegEx)
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtRegExxxx1 = " . TxtRegEx , SLU.log ;;;- Debug -;;;
*/

;        TxtRegEx := TxtRegEx = "*" ? "[^\/]" : ToRegEx(TxtRegEx)
        If TxtRegEx = *
          TxtRegEx =
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtRegExxxx2 = " . TxtRegEx , SLU.log ;;;- Debug -;;;
*/
        TxtRegEx := "<" . ToRegEx(TxtRegEx) . "[^>]*?>"
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtRegExxxx3 = " . TxtRegEx , SLU.log ;;;- Debug -;;;
*/
        TxtRegEx := XMLent(TxtRegEx)
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtRegExxxx4 = " . TxtRegEx , SLU.log ;;;- Debug -;;;
*/      
        ;match
        Grep(FilterTxt, "is)(\([^\)]*\))", TxtItem)
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtItemxxxx = " . TxtItem , SLU.log ;;;- Debug -;;;
*/  
        StringSplit, TxtItem, TxtItem, % chr(4)
        TxtItem=
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtItem0 = " . TxtItem0 , SLU.log ;;;- Debug -;;;
*/
        ; No () e.g. slate.com#hr
        If TxtItem0 = 0
        {
           TxtItem:=SubStr(TxtRegEx, 1, StrLen(TxtRegEx) - 13)
        }
        Else
        {
          Loop, %TxtItem0%
          {
            tmpstr3=
            RegExMatch(TxtItem%A_Index%, "is)(?<=\()([^\=\)]*)(?:\=)*([^\)]*)", tmpstr)
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
  {
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> tmpstr = " . tmpstr , SLU.log ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> tmpstr0 = " . tmpstr0 , SLU.log ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> tmpstr1 = " . tmpstr1 , SLU.log ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> tmpstr2 = " . tmpstr2 , SLU.log ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> tmpstr3 = " . tmpstr3 , SLU.log ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> tmpstr4 = " . tmpstr4 , SLU.log ;;;- Debug -;;;
  }
*/
            ; No = in () rule e.g. 163.com#DIV(adMenu)  
            If tmpstr2=
            {
;              tmpstr3 := "[^\s]*?\s*?\=\s*?$STR(" ToRegEx(tmpstr1) ")"
              tmpstr3 := "[^\s]*?\s*?\=\s*?(?:""" ToRegEx(tmpstr1) """|'" ToRegEx(tmpstr1) "'|" ToRegEx(tmpstr1) "(?=[\s>'""]))"

              TxtItem := TxtItem . tmpstr3 . "|"

              If A_Index = 1
              {
                RegTo:="[^&gt;]*?" XMLent(ToRegEx(tmpstr1)) "[^&gt;]*?&gt;"
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtRegEx1 = " . RegTo , SLU.log ;;;- Debug -;;;
*/
;                TxtRegEx := RegExReplace(TxtRegEx, "\[\^\\\&gt\;\]\*\?\\\&gt\;$", RegTo)
                TxtRegEx := SubStr(TxtRegEx, 1, StrLen(TxtRegEx) - 13) . RegTo
              }
            }
            Else
            {
              If A_Index = 1
              {
                RegTo:="[^&gt;]*?" XMLent(ToRegEx(RegExReplace(tmpstr1, "[\^|\$|\*]$", ""))) "[^&gt;]*?\=[^&gt;]*?" XMLent(ToRegEx(tmpstr2)) "[^&gt;]*?&gt;"
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> RegTo = " . RegTo , SLU.log ;;;- Debug -;;;
*/
;                TxtRegEx := RegExReplace(TxtRegEx, "\[\^\\\&gt\;\]\*\?\\\&gt\;$", RegTo)
                TxtRegEx := SubStr(TxtRegEx, 1, StrLen(TxtRegEx) - 13) . RegTo
              } 
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtRegEx2 = " . TxtRegEx , SLU.log ;;;- Debug -;;;
*/
              ;; ^=
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\^$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\^$", "")) "\s*?\=\s*?$STR(" ToRegEx(tmpstr2) ".*?)" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\^$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\^$", "")) "\s*?\=\s*?(?:""" ToRegEx(tmpstr2) "[^""]*?""|'" ToRegEx(tmpstr2) "[^']*?'|" ToRegEx(tmpstr2) "[^\s>'""]*?(?=[\s>'""]))": "")
              ;; $=
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\$$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\$$", "")) "\s*?\=\s*?$STR(.*?" ToRegEx(tmpstr2) ")" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\$$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\$$", "")) "\s*?\=\s*?(?:""[^""]*?" ToRegEx(tmpstr2) """|'[^']*?" ToRegEx(tmpstr2) "'|[^\s>'""]*?" ToRegEx(tmpstr2) "(?=[\s>'""]))": "")
              ;; *=
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\*$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\*$", "")) "\s*?\=\s*?$STR(.*?" ToRegEx(tmpstr2) ".*?)" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\*$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\*$", "")) "\s*?\=\s*?(?:""[^""]*?" ToRegEx(tmpstr2) "[^""]*?""|'[^']*?" ToRegEx(tmpstr2) "[^']*?'|[^\s>'""]*?" ToRegEx(tmpstr2) "[^\s>'""]*?(?=[\s>'""]))": "")
              ;; =
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "[\^|\$\*]$") = 0 ? ToRegEx(tmpstr1) "\s*?\=\s*?$STR(" ToRegEx(tmpstr2) ")" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "[\^|\$\*]$") = 0 ? ToRegEx(tmpstr1) "\s*?\=\s*?(?:""" ToRegEx(tmpstr2) """|'" ToRegEx(tmpstr2) "'|" ToRegEx(tmpstr2) "(?=[\s>'""]))": "")
              
              TxtItem := TxtItem . tmpstr3 . "|" 
            }
          }
  
          ; Remove last |
          TxtItem:=RegExReplace(TxtItem, "\|$", "")

          ; For more than 1 () rule e.g. 3quote.info#TD(width=364)(height=280)  
          if TxtItem0 > 1
            TxtItem:="(?:(?:" . TxtItem . ").*?){" TxtItem0 "}"
  
          TxtItem:=XMLent(TxtItem)
        }
        TxtItem:="(" TxtItem ")"
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> TxtItem = " . TxtItem , SLU.log ;;;- Debug -;;;
*/
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;BlackList
      Else
      {
        TxtDomain = *
        TxtType = B
        TxtRegEx := RegExMatch(FilterTxt, "is)^\/.*\/$") > 0 ? 1 : 0
        If TxtRegEx = 1
        {
          ;;; /.../
          TxtItem := RegExReplace(FilterTxt, "is)^\/", "")
          TxtItem := RegExReplace(TxtItem, "is)\/$", "")
        }
        Else
        {
          ;;; Remove filter options $, ********* Not support in Maxthon2 *********
          ;;; 
          ;;; http://adblockplus.org/en/filters
          ;;; $ / $~
          ;;; script — external scripts loaded via HTML script tag
          ;;; image — regular images, typically loaded via HTML img tag
          ;;; background — background images, often specified via CSS
          ;;; stylesheet — external CSS stylesheet files
          ;;; object — content handled by browser plugins, e.g. Flash or Java
          ;;; xbl — XBL bindings (typically loaded by -moz-binding CSS property) Firefox 3 or higher required
          ;;; ping — link pings Firefox 3 or higher required
          ;;; xmlhttprequest — requests started by the XMLHttpRequest object Firefox 3 or higher required
          ;;; object-subrequest — requests started plugins like Flash Firefox 3 or higher required
          ;;; dtd — DTD files loaded by XML documents Firefox 3 or higher required
          ;;; subdocument — embedded pages, usually included via HTML frames
          ;;; document — the page itself (only exception rules can be applied to the page)
          ;;; other — types of requests not covered in the list above (in Firefox 2 this includes XBL bindings and XMLHttpRequests as well)
          ;;; match-case — makes the filter only apply to addresses with matching letter case
          ;;; collapse — this option will override the global “Collapse blocked elements” and make sure the filter always collapses the element

          TxtItem := RegExMatch(FilterTxt, "is)\$") > 0 ? "" : FilterTxt
          If RegExMatch(TxtItem, "is)^\|") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\|$") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\?") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\^") > 0
            TxtRegEx = 1

          If TxtRegEx = 1
            TxtItem := ToRegEx(TxtItem)
            
          ;;; ||
          If RegExMatch(TxtItem, "is)^\\\|") > 0
            TxtItem := RegExReplace(TxtItem, "is)^\\\|", "[\/|\.]")
          ;;; ^
          If RegExMatch(TxtItem, "is)\\\^") > 0          
            TxtItem := RegExReplace(TxtItem, "is)\\\^", "[^\w\-\.\%]")          

          TxtItem := RegExReplace(TxtItem, "is)^\.\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\.\*$", "")
          TxtItem := RegExReplace(TxtItem, "is)^\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\*$", "")
        }
        TxtItem := XMLent(TxtItem)
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      SQL_str:="insert into " TableName " values ('" XMLent(FilterName) "', " A_Index ", '" XMLent(FilterTxt) "', '" TxtDomain "', '" TxtType "', '" TxtRegEx "', '" TxtItem "');"
/*
If FilterName=ChinaList ;;;- Debug -;;;
;  If (OOO_Count > 390) and (OOO_Count < 415) ;;;- Debug -;;;
  {
    FileAppend % "`n" . A_Tab . A_Tab . A_Tab . A_Tab . A_Tab ">> SQL_str = " . SQL_str , SLU.log ;;;- Debug -;;;
  }
*/
      ;;SQL
      $iRC := _SQLite_Exec($SQLITE_h_DB, SQL_str)
      If ($iRC <> $SQLITE_OK)
      {
/*
         FileAppend %A_Tab%%A_Tab%SQLite Exec ERROR: %$iRC% - %$SQLITE_s_ERROR%, SLU.log ;;;- Debug -;;;
*/
         MsgBox SQLite Exec ERROR: %$iRC% - %$SQLITE_s_ERROR%
         $iRC := _SQLite_CloseDB(-1)
         $iRC := _SQLite_ShutDown()
         GUIExit()
      }
/*
If FilterName=ChinaList
;  If (OOO_Count > 390) and (OOO_Count < 415)
  {
    FileAppend `n%A_Tab%%A_Tab%%A_Tab%%A_Tab%%A_Tab%>> OK`n, SLU.log ;;;- Debug -;;;
  }
*/
    }
  Return
}

;;;;;;;;;;;;;;;;;;
;; break sitelist.xml and insert into SQLite tables
;;;;;;;;;;;;;;;;;;

Process_SiteList(filename, tablename)
{
  Global UTF8BOM, $SQLITE_OK, $SQLITE_ERROR, $SQLITE_INTERNAL, $SQLITE_PERM, $SQLITE_ABORT, $SQLITE_BUSY, $SQLITE_LOCKED, $SQLITE_NOMEM, $SQLITE_READONLY, $SQLITE_INTERRUPT, $SQLITE_IOERR, $SQLITE_CORRUPT, $SQLITE_NOTFOUND, $SQLITE_FULL, $SQLITE_CANTOPEN, $SQLITE_PROTOCOL, $SQLITE_EMPTY, $SQLITE_SCHEMA, $SQLITE_TOOBIG, $SQLITE_CONSTRAINT, $SQLITE_MISMATCH, $SQLITE_MISUSE, $SQLITE_NOLFS, $SQLITE_AUTH, $SQLITE_ROW, $SQLITE_DONE, $SQLITE_s_VERSION, $SQLITE_s_DLL, $SQLITE_s_EXE, $SQLITE_s_DB, $SQLITE_h_DLL, $SQLITE_h_DB, $SQLITE_h_QUERY, $SQLITE_s_ERROR
  FileRead,XML,%filename% 

;  XML:=RegExReplace(XML, "is)(\t|\r|\n)", "")
  Grep(XML, "is)<m2filter.*?<\/m2filter>", m2filter)
  StringSplit, m2filter, m2filter, % chr(4)
   
   ;--- For every entry of <m2filter.....</m2filter>
   Loop
   {
      if m2filter%A_Index% =
         break
      
      RegExMatch(m2filter%A_Index%, "is)<m2filter.*?d\=\""(.*?)\""", Domain)
      Domain:=Domain1
      Domain1=
   
      ;---------- blacklist
      RegExMatch(m2filter%A_Index%, "is)(<blacklist(\s*?\/>|.*?<\/blacklist>))", filterList)
      blackwhite=B
      filterList:=filterList1
      filterList1=
      Process_list(Domain, blackwhite, filterList, tablename)

      ;---------- whitelist
      RegExMatch(m2filter%A_Index%, "is)(<whitelist(\s*?\/>|.*?<\/whitelist>))", filterList)
      blackwhite=W
      filterList:=filterList1
      filterList1=
      Process_list(Domain, blackwhite, filterList, tablename)
   }
}

;;;;;;;;;;;;;;;;;;
;; break item
;;;;;;;;;;;;;;;;;;
Process_list(Domain, blackwhite, filterList, tablename)
{
  Global UTF8BOM, $SQLITE_OK, $SQLITE_ERROR, $SQLITE_INTERNAL, $SQLITE_PERM, $SQLITE_ABORT, $SQLITE_BUSY, $SQLITE_LOCKED, $SQLITE_NOMEM, $SQLITE_READONLY, $SQLITE_INTERRUPT, $SQLITE_IOERR, $SQLITE_CORRUPT, $SQLITE_NOTFOUND, $SQLITE_FULL, $SQLITE_CANTOPEN, $SQLITE_PROTOCOL, $SQLITE_EMPTY, $SQLITE_SCHEMA, $SQLITE_TOOBIG, $SQLITE_CONSTRAINT, $SQLITE_MISMATCH, $SQLITE_MISUSE, $SQLITE_NOLFS, $SQLITE_AUTH, $SQLITE_ROW, $SQLITE_DONE, $SQLITE_s_VERSION, $SQLITE_s_DLL, $SQLITE_s_EXE, $SQLITE_s_DB, $SQLITE_h_DLL, $SQLITE_h_DB, $SQLITE_h_QUERY, $SQLITE_s_ERROR
  Grep(filterList, "is)<item.*?<\/item>", filterList)
  StringSplit, filterList, filterList, % chr(4)
  
  Loop
  {
     if filterList%A_Index% =
        break
        
     RegExMatch(filterList%A_Index%, "is)<item.*?mode\=\""(.*?)\"".*?>([^<]*)", item)

     ;--- If rules exists in new version then ignore
     $iRC := _SQLite_Exec($SQLITE_h_DB, "insert into " tablename " values ('', 0, '', '" Domain "','" blackwhite "','" item1 "','" item2 "');")      
      If ($iRC <> $SQLITE_OK)
      {
         MsgBox SQLite Exec ERROR: %$iRC% - %$SQLITE_s_ERROR%
         $iRC := _SQLite_CloseDB(-1)
         $iRC := _SQLite_ShutDown()
         GUIExit()
      }
  }
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;--- validate checksum of subscribed filter
#include MD5.ahk
#include ChgCP.ahk
ABPCheckSumValidate(nContents)
{
  ;Change to ANSI for processing
  nContents:=UTF82ANSI(nContents)
  
  ;Get existing checksum for validation
  RegExMatch(nContents, "is)(?:[\n]!\s*?Checksum[\s\-:]+\s*)([^\s]*)", chksum)
  chksum:=chksum1
  chksum1=
  
  ; If no checksum exists, no need to validate
  if chksum=
    Return true
    
  ;;; Normalize
  ;Remove already existing checksum
  nContents:=RegExReplace(nContents, "is)(?:[\n]!\s*?Checksum[\s\-:]+\s*)([^\s]*)", "")

  ;Calculate new checksum: remove all CR symbols and empty
  ;lines and get an MD5 checksum of the result (base64-encoded,
  ;without the trailing = characters).
  nContents:=RegExReplace(nContents, "is)\r", "")
  nContents:=RegExReplace(nContents, "is)\n+", "`n")
  
  ;Change back to UTF-8 for checksum generation
  nContents:=ANSI2UTF8(nContents)

  ; Get MD5-Base64 Hash
  MD5Hash_Base64:=MD5_Base64(nContents, StrLen(nContents))

  Return (MD5Hash_Base64 = chksum) ? true : false
}
