﻿;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;
;; Sub-Routine to gen SiteList
;;;;;;;;;;;;;;;;;;
SQLgenFilter:
GoSub SiteListUpdater_xml
GoSub SiteListUpdaterNoURL_xml
Return

;;; Generate SiteListUpdater.xml
SiteListUpdater_xml:
$vSiteList=
(
<?xml version="1.0" encoding="utf-8"?>
<m2filter version="1.0">
<package version="%Today%" author="pekkle @ HKSAR" description="by SiteListUpdater Plugins &lt;a href='http://forum.maxthon.com/viewthread.php?tid=63708' target=_blank&gt;English Forum&lt;/a&gt; &lt;a href='http://bbs.maxthon.cn/viewthread.php?tid=9300' target=_blank&gt;&#20013;&#25991;&#35770;&#22363;&lt;/a&gt;" support_url="http://bbs.maxthon.cn/viewthread.php?tid=9300" title="SiteListUpdater"/>
<filterlist>
)

$sSQL =
( 
    select distinct '<filter enable="1" name="' || filtername || '/' || txt || '"',
           'match_url="' || domain || '"',
           'bound="' || regex || '"',
           'match="' || item || '"',
           'replace="$1 style\=display\:none\;"' ||
           ' type="text" action="3" priority="0" postaction=""' ||
           ' max_bound_size="128" author="" comment="" exclude_url=""' ||
           ' match_count="" exclude="style\=display\:none\;"' ||
           ' update="" ver="1.0" keywords=""/>' rule
    from tmp
    where type = 'E'
    and domain <> ''
    and item <> ''
    order by filtername, txt;
)
$iRC := _SQLite_GetTable($SQLITE_h_DB, $sSQL, $sResult, $iRows, $iCols, -1, 4096)
If ($iRC <> $SQLITE_OK)
{
   MsgBox SQLite GetTable ERROR: %$iRC% - %$SQLITE_s_ERROR%
   $iRC := _SQLite_CloseDB(-1)
   $iRC := _SQLite_ShutDown()
   GUIExit()
}

Loop, Parse, $sResult, `n
{
If (A_Index > 1)
{
StringReplace s_LoopField, A_LoopField, "|, "%A_Space%, ALL

$vSiteList=
(
%$vSiteList%
%s_LoopField%
)
}
}

$vSiteList=
(
%$vSiteList%
</filterlist>
</m2filter>
)

FileDelete SiteList.XML\SiteListUpdater.xml
FileAppend %$vSiteList%, SiteList.XML\SiteListUpdater.xml

Return

;;; Generate SiteListUpdaterNoURL.xml
SiteListUpdaterNoURL_xml:
$vSiteList=
(
<?xml version="1.0" encoding="utf-8"?>
<m2filter version="1.0">
<package version="%Today%" author="pekkle @ HKSAR" description="by SiteListUpdater Plugins &lt;a href='http://forum.maxthon.com/viewthread.php?tid=63708' target=_blank&gt;English Forum&lt;/a&gt; &lt;a href='http://bbs.maxthon.cn/viewthread.php?tid=9300' target=_blank&gt;&#20013;&#25991;&#35770;&#22363;&lt;/a&gt;" support_url="http://bbs.maxthon.cn/viewthread.php?tid=9300" title="SiteListUpdaterNoURL"/>
<filterlist>
)

$sSQL =
( 
    select distinct '<filter enable="1" name="' || filtername || '/' || txt || '"',
           'match_url="' || domain || '"',
           'bound="' || regex || '"',
           'match="' || item || '"',
           'replace="$1 style\=display\:none\;"' ||
           ' type="text" action="3" priority="0" postaction=""' ||
           ' max_bound_size="128" author="" comment="" exclude_url=""' ||
           ' match_count="" exclude="style\=display\:none\;"' ||
           ' update="" ver="1.0" keywords=""/>' rule
    from tmp
    where type = 'E'
    and domain = ''
    and item <> ''
    order by filtername, txt;
)
$iRC := _SQLite_GetTable($SQLITE_h_DB, $sSQL, $sResult, $iRows, $iCols, -1, 4096)
If ($iRC <> $SQLITE_OK)
{
   MsgBox SQLite GetTable ERROR: %$iRC% - %$SQLITE_s_ERROR%
   $iRC := _SQLite_CloseDB(-1)
   $iRC := _SQLite_ShutDown()
   GUIExit()
}

Loop, Parse, $sResult, `n
{
If (A_Index > 1)
{
StringReplace s_LoopField, A_LoopField, "|, "%A_Space%, ALL

$vSiteList=
(
%$vSiteList%
%s_LoopField%
)
}
}

$vSiteList=
(
%$vSiteList%
</filterlist>
</m2filter>
)

FileDelete SiteList.XML\SiteListUpdaterNoURL.xml
FileAppend %$vSiteList%, SiteList.XML\SiteListUpdaterNoURL.xml

Return
