﻿SetIEProxy()
{
  RegRead, ProxyEnable, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Internet Settings, ProxyEnable
  if ErrorLevel
    ProxyEnable = 0
  
  if ProxyEnable = 1
  {
    RegRead, ProxyServer, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Internet Settings, ProxyServer
    if ErrorLevel
      ProxyServer =
  
    If RegExMatch(ProxyServer, "is)\;") > 0
    {
      RegExMatch(ProxyServer, "is)ftp\=([^\;]*)", FTP_Proxy)
      FTP_Proxy := FTP_Proxy1
      FTP_Proxy1 =
  
      RegExMatch(ProxyServer, "is)gopher\=([^\;]*)", GOPHER_Proxy)
      GOPHER_Proxy := GOPHER_Proxy1
      GOPHER_Proxy1 =
  
      RegExMatch(ProxyServer, "is)http\=([^\;]*)", HTTP_Proxy)
      HTTP_Proxy := HTTP_Proxy1
      HTTP_Proxy1 =
  
      RegExMatch(ProxyServer, "is)https\=([^\;]*)", HTTPS_Proxy)
      HTTPS_Proxy := HTTPS_Proxy1
      HTTPS_Proxy1 =
  
      RegExMatch(ProxyServer, "is)socks\=([^\;]*)", SOCKS_Proxy)
      SOCKS_Proxy := SOCKS_Proxy1
      SOCKS_Proxy1 =
      
      ALL_Proxy =
    }
    else
    {
      FTP_Proxy =
      GOPHER_Proxy =
      HTTP_Proxy =
      HTTPS_Proxy =
      SOCKS_Proxy =
      ALL_Proxy := ProxyServer
    }
    
    RegRead, ProxyOverride, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Internet Settings, ProxyOverride
    if ErrorLevel
      ProxyOverride =
      
    ProxyOverride := RegExReplace(ProxyOverride, "is)\;\s*?", ",")
    ProxyOverride := RegExReplace(ProxyOverride, "is)\<local\>", "")
    ProxyOverride := RegExReplace(ProxyOverride, "is)^\,", "")
    ProxyOverride := RegExReplace(ProxyOverride, "is)\,$", "")
  }
  Else
  {
      ProxyOverride =
      FTP_Proxy =
      GOPHER_Proxy =
      HTTP_Proxy =
      HTTPS_Proxy =
      SOCKS_Proxy =
      ALL_Proxy =
  }
  
  EnvSet, HTTP_PROXY, %HTTP_Proxy%
  EnvSet, HTTPS_PROXY, %HTTPS_Proxy%
  EnvSet, FTP_PROXY, %FTP_Proxy%
  EnvSet, ALL_PROXY, %ALL_Proxy%
  EnvSet, NO_PROXY, %ProxyOverride%
}  
